#!/usr/bin/python


################################################################
#
# Copyright (C) 2004 Tez Kamihira
#
# See the file "COPYING" for further information about
# the copyright and warranty status of this work.
#

################################################################
# callback.py -- user defined callback functions.

LIB_DIR = None

import sys

if LIB_DIR:
  sys.path.insert(0, LIB_DIR)

import os
import re
import tlatools

def cb_common(vrev, scm_rev_name, curr_rank, max_rank):

    [a, c, b, v, r] = tlatools.split_acbvr(scm_rev_name)

    if c.upper() == 'VIEWARCH':  # yep, hard coded. any claim ? :)
        m = re.match(r"^(\d+)\.(\d+)\.(\d+)$", v)
        if m:
            vv = m.group(3)
            m = re.match(r"^.*-(\d+)$", r)
            if m:
                rr = m.group(1)
                return 'ViewARCH-%s-%s' % (vv, rr)

    return str(vrev)



###############################################################
# line_header_cb() -- line header callback function.
#                     you can customize it.
###############################################################
def line_header_cb(vrev, scm_rev_name, curr_rank, max_rank):

    return str(vrev)

"""
#
# example: display full qualified revision name.
#
def line_header_cb(vrev, scm_rev_name, curr_rank, max_rank):

    return scm_rev_name

#
# example: display partial decorated name.
#
def line_header_cb(vrev, scm_rev_name, curr_rank, max_rank):

    # split_acbvr() is internal subroutine of ViewARCH.
    # the meaning is apparent, isn't it ? :)

    [a, c, b, v, r] = tlatools.split_acbvr(scm_rev_name)

    return v + '--' + r

"""

###############################################################
# revlist_header_cb() -- revision list callback function.
#                        you can customize it.
###############################################################
def revlist_header_cb(vrev, scm_rev_name, curr_rank, max_rank):

    return cb_common(vrev, scm_rev_name, curr_rank, max_rank)

###############################################################
# invhist_header_cb() -- inventory history list callback function.
#                        you can customize it.
###############################################################
def invhist_header_cb(vrev, scm_rev_name, curr_rank, max_rank):

    return cb_common(vrev, scm_rev_name, curr_rank, max_rank)

# arch-tag: 2241e1c8-5c89-4275-83bf-c415a5a65417
