#!/usr/bin/python

################################################################
#
# Copyright (C) 2004 Tez Kamihira
#
# See the file "COPYING" for further information about
# the copyright and warranty status of this work.
#

################################################################
#
# noise-reductor.py
#
#  noise reductor for tla's  "?./{arch}/..."  v.s.  "A_./{arch}/..." bug,
#   when ViewARCH's self sanity checking.
#
#  this bug breaks reverse changeset's applying when you use "name" tagging
#   method.
#
#  see below:
#
################################################################

'''
[2004/11/30 09:58:50] c lord@emf.net--2003b/docs-hackerlab--devo--1.0--patch-1
--- tom/files
+++ tez/files
@@ -84,4 +84,4 @@
 {arch}/.arch-project-tree	?./{arch}/.arch-project-tree
 {arch}/=tagging-method	?./{arch}/=tagging-method
 {arch}/docs-hackerlab/docs-hackerlab--devo/docs-hackerlab--devo--1.0/lord@emf.net--2003b/patch-log/base-0	?./{arch}/docs-hackerlab/docs-hackerlab--devo/docs-hackerlab--devo--1.0/lord@emf.net--2003b/patch-log/base-0
-{arch}/docs-hackerlab/docs-hackerlab--devo/docs-hackerlab--devo--1.0/lord@emf.net--2003b/patch-log/patch-1	?./{arch}/docs-hackerlab/docs-hackerlab--devo/docs-hackerlab--devo--1.0/lord@emf.net--2003b/patch-log/patch-1
+{arch}/docs-hackerlab/docs-hackerlab--devo/docs-hackerlab--devo--1.0/lord@emf.net--2003b/patch-log/patch-1	A_./{arch}/docs-hackerlab/docs-hackerlab--devo/docs-hackerlab--devo--1.0/lord@emf.net--2003b/patch-log/patch-1
'''

################################################################
#
# also filter out some ChangeLog's inconsistency.
#
#  see below:
#
################################################################

'''
[2004/12/01 13:44:40] c lord@emf.net--2003b/hackerlab--devo--1.0--patch-6
inventory: i_automatic-ChangeLog--lord@emf.net--2003b/hackerlab--devo--1.0
encoded iv: ./tmp/lord@emf.net--2003b/hackerlab--devo--1.0/inventory/91/aV9hdXRvbWF0aWMtQ2hhbmdlTG9nLS1sb3JkQGVtZi5uZXQtLTIwMDNiL2hhY2tlcmxhYi0tZGV2by0tMS4w.gz
--- tom/var/tmp/,,ZmGPFs.ViewARCH/tree/ChangeLog
+++ tez/var/tmp/,,ZmGPFs.ViewARCH/tree/ChangeLog
@@ -2,7 +2,7 @@
 # tag: automatic-ChangeLog--lord@emf.net--2003b/hackerlab--devo--1.0
 #
 
-2003-06-16 06:11:22 GMT	Tom Lord <lord@emf.net>	patch-6
+2003-06-16 GMT	Tom Lord <lord@emf.net>	patch-6
 
        ...

'''
################################################################

import sys
import re

def _main():

    fn = sys.argv[1]

    f = open(fn, "r")
    lines = f.readlines()
    f.close()

    b_clog_skip_mode = 0

    for i in range(len(lines)):

        if b_clog_skip_mode == 1:
            if lines[i][0] == '[':
                b_clog_skip_mode = 0
            else:
                continue

        if re.match(r"^---.*Change[lL]og[^/]*$", lines[i]):
            b_clog_skip_mode = 1
            continue

        if re.match(r"^-\S+\s+\?\.\/\{arch\}\/", lines[i]):
            continue
        if re.match(r"^\+\S+\s+A_\.\/\{arch\}\/", lines[i]):
            continue
        if re.match(r"^ ", lines[i]):
            continue
        print lines[i],

if __name__ == '__main__': _main()

# arch-tag: 42d97e39-f509-4d27-8042-2b35db19278a

