#!/usr/bin/python

################################################################
#
# Copyright (C) 2004 Tez Kamihira
#
# See the file "COPYING" for further information about
# the copyright and warranty status of this work.
#

import sys
import os
import string
import re

class summary:

    def __init__(self, f):

        self.f = f
        self.ymd_acbv = {}
        try:
            ff = open(f)
            l = ff.readline()
            while l:

                #
                # "YYYY-MM-DD HH:MM:SS GMT a/c--b--v"
                #

                l = l[:-1]
                self.ymd_acbv[ l[24:] ] = l[:23]

                l = ff.readline()

            ff.close()

        except Exception:
            pass

    def flush(self):

        tlist = []
        keys = self.ymd_acbv.keys()
        for i in range(len(keys)):
            tlist.append( "%s %s" % ( self.ymd_acbv[ keys[i] ], keys[i] ) ) 

        tlist.sort()
        tlist.reverse()
        tmp = self.f + ".tmp"
        f = open(tmp, 'w')
        for i in range(len(tlist)):
            f.write("%s\n" % tlist[i])
        f.close()

        os.rename(tmp, self.f)

    def append(self, tm, a, cbv):

        self.ymd_acbv[a + '/' + cbv] = tm

    def getlist(self):

        tlist = []
        keys = self.ymd_acbv.keys()
        for i in range(len(keys)):
            tlist.append( "%s %s" % ( self.ymd_acbv[ keys[i] ], keys[i] ) ) 

        tlist.sort()
        tlist.reverse()

        return map(lambda x: [ x[:23], x[24:] ], tlist)

def _main():

    # 2004-02-10 05:10:26 GMT

    a = summary(",,taco")
    a.append("2004-02-10 05:10:26 GMT", "a@b.c", "a--b--c")
    a.append("1009-05-10 01:02:03 GMT", "d@e.f", "hello--wor-ld")
    a.append("3009-05-10 01:02:03 GMT", "g@h.i", "tezzy--aa--b")
    a.flush()

    print a.getlist()

if __name__ == '__main__': _main()

# arch-tag: 685ec7c3-e035-40b2-8de3-d736b30507ab
